

New features in 2.2 since 2.0
*****************************

   * Setting `raggedlast = ##t' in the `\paper' block causes the last
     line to be set flush-left instead of justified.

   * The `Timing_engraver' now sets the `Timing' alias on its
     containing context automatically.

   * The code for font selection has been rewritten. In addition to
     existing font selection properties, the property `font-encoding'
     has been added, which makes the switch between normal `text' and
     other encodings like `braces', `music' and `math'.

   * The pmx2ly script has been removed from the distribution.

   * Pedal brackets will now run to the last bar of a piece if they are
     not explicitly ended.

   * Context definitions now use the word `\context' instead of
     `\translator'.

   * Property functions may be used as an argument to `set!', for
     example

            (set! (ly:grob-property grob 'beam) ... )

   * In anticipation of Emacs 21.4 or 22.1, the info documentation
     contains images.

   * Cue notes can be quoted directly from the parts that contain them.
     This will take into account transposition of source and target
     instrument. For example,


     \addquote clarinet \notes\relative c' {
       \transposition bes
       fis4 fis fis fis
     }
     
     \score {
         \notes \relative c'' {
     	c8 d8 \quote 2 oboe es8 gis  
         }
     }

   * The transposition of an instrument can be specified using the
     `\transposition' command.  An E-flat alto saxophone is specified as

            \transposition es'

   * The naming of exported Scheme functions now follows Scheme
     conventions.  Changes be applied to Scheme files with

                  convert-ly -e -n --from=2.1.24 --to=2.1.26 *.scm

   * Notes can  be excluded from auto-beaming, by  marking them with
     `\noBeam'
            c8 c \noBeam c c

     will print two separate eighth notes, and two beamed notes.

   * Translators and contexts have been split. The result of this
     internal cleanup is that `Score' no longer is the top context;
     `Score' is contained in the `Global' context. Consequently, it is
     possible to tweak `Score' as follows:

            \context Score \with {
              ...
            }

   * The number of staff lines  in Tablature notation is now
     automatically deduced from the `stringTunings' property.

   * The program reference has been cleaned up and revised.

   * The syntax for setting properties has been simplified: the
     following table lists the differences:

                (old)                           (new)
          
          \property A.B = #C                \set A.B = #C
          \property A.B \unset              \unset A.B
          \property A.B \set #C = #D        \override A.B #C = #D
          \property A.B \override #C = #D   (removed)
          \property A.B \revert #C          \revert A.B #C

     Furthermore, if `A' is left out, the bottommost context is used by
     default.  In other words, it is no longer necessary to explicitly
     mention `Voice', `Lyrics' or `ChordNames'.

     Old:

             \property Voice.autoBeaming = ##f
             \property Staff.TimeSignature \set #'style = #'C

     New:

             \set autoBeaming = ##f
             \override Staff.TimeSignature #'style = #'C

   * Tweaks  made with `\override' and `\revert' no longer hide tweaks
     at higher context levels.

   * Melismata in lyrics are also properly handled  in the MIDI output.

   * The lilypond-book script has been rewritten.  It is shorter,
     cleaner and faster.  The special construct `mbinclude' has been
     removed, plain `@include' or `\input' can be used now.

     It now supports running convert-ly on the lilypond snippets,
              lilypond-book --filter='convert-ly --from=2.0.0' my-book.tely

   * The `LyricsVoice' context has been removed. Lyrics should only be
     constructed in `Lyrics'.

   * The `Thread' context has been removed. Note heads and rests are
     now constructed at `Voice' level.

   * Harmonic notes can now be entered as

             <c' g''\harmonic>

   * Drum notation is now supported  as a regular feature: percussion
     may be entered in `\drums' mode, and printed or performed in a
     `DrumStaff' context:

            \score {
              \drums \new DrumStaff { hihat4 cowbell8 }
            }

   * The automatic staff changer was internally rewritten. As a result,
     the syntax has been simplified as well:

            \autochange THE-MUSIC

   * The ergonomic syntax of `\markup' now has an equivalent in Scheme.
     The `markup*' macro creates such objects; the following two markup
     commands are equivalent:
           f4^#(markup* #:raise 0.2 #:bold "hi")
           f4^\markup { \raise #0.2 \bold hi  }

   * Voice names, for vocal lines, have been added. They are similar to
     instrument names.   They can be set by defining `vocalName' and
     `vocNam'.

   * Safe mode has been reinstated for lilypond.  When lilypond is
     invoked with `--safe-mode', TeX and PostScript file output is
     disallowed, and lilypond-bin is invoked with `--safe-mode', the
     user's Guile expressions are evaluated in a safe environment and
     file inclusion is not allowed.

     Warning: this does not protect against denial-of-service attacks
     using Guile, TeX or PostScript.

     (This feature is still experimental.)

   * There is now a Scheme macro for defining markup commands. Special
     mark-up commands can be defined in user-files too.

   * Many fixes for dimension scaling have been made, resulting in
     correct results for scores that mix staves in different sizes.

   * Improved robustness when  layout properties are accidentally
     removed.

   * A  more cleanly constructed part combiner has been installed.  It
     is more robust and less buggy. The part-combiner can be used with
            \partcombine MUS1 MUS2

     See `input/regression/new-part-combine.ly' for an example.

   * Formatting of rehearsal marks has been improved. The `\mark'
     command now only does automatic incrementing for marks specified as
     integer. For example, `\mark #1' will print an A in the default
     style.  See `input/regression/rehearsal-mark-letter.ly',
     `input/regression/rehearsal-mark-number.ly'.

   * Formatting of ottava brackets has been much improved.

   * Objects in the output can now be documented: the following fragment
     boxes the note head, and adds the text "heads or tails?" three
     spaces below the box.

                 \context Voice \applyoutput #(add-balloon-text
          				     'NoteHead "heads, or tails?"
          				     '(0 . -3))
          
          
                 c8

   * Default staff sizes are now scalable. There are two new mechanisms
     for setting staff sizes. Both are demonstrated in this fragment:

            #(set-global-staff-size 15)
            \paper {
              #(paper-set-staff-size (* 15 pt))
            }

     Both have the same effect on the global layout of a piece.
     Similarly, the paper size may be changed as follows

            #(set-default-paper-size "a4")
            \paper {
              #(set-paper-size "a4")
            }

   * Warnings for bar check errors are more cleverly printed.  This
     makes `barCheckSynchronize' superfluous, so it is now switched off
     by default.

     Warning: this will cause problems in scores that use bar checks to
     shorten measures.

   * The black note head was made a little rounder, which causes a less
     frantic graphic impression.

   * A more concise syntax for checking octaves was introduced. A note
     may be followed by `='QUOTES which indicates what its absolute
     octave should be.  In the following example,

            \relative c'' { c='' b=' d,='' }

     the d will generate a warning, because a d" is expected, but a d'
     is found.

   * There is a new mechanism for putting lyrics to melodies.  With
     this mechanism, `Lyrics' lines can be put melodies individually,
     allowing for different melismatic sections in every `Lyrics'. See
     `input/regression/lyric-combine-new.ly'.

   * Bar lines may now be dotted.

   * The documentation now has links to a wiki, where everyone can add
     personal comments to the manual.

   * Contexts may now be changed locally for an isolated music
     expression. For example,

            \new Voice \with {
               \consists "Pitch_squash_engraver"
            } {
              c'4
            }

   * The syntax for changing staffs has changed. The keyword `\change'
     should now be used, e.g.

            \change Staff = up

   * Features of spanner contexts, like `Staff', can now be changed
     using `\set', eg.

            \new Staff {
                 \override Staff.StaffSymbol #'line-count = #4
                 c'4
            }

     puts a quarter note C on a staff with 4 lines.

   * Multi measure rests are now truly centered between the
     clefs/barlines of the staff, their position is independent of
     symbols on the other staffs.

   * Collision resolution for dots in chords has been improved greatly.

   * Spacing following barlines was improved for widely stretched lines.

   * Lyric hyphens and extenders now conform to standard typesetting
     practice.

   * Lyrics are now aligned under note heads conforming to engraving
     standards. The responsible code has been rewritten, and is
     drastically simpler from the previous version. To aid this
     rewrite, the syntactic function of the extender line ( __ ) has
     been changed: it is now attached to the lyric syllable.

   * When redefining a context, the associated identifier is also
     updated. For example, after reading

           \translator {
                  \ScoreContext
                  autoBeaming = ##f
           }

     the definition of `ScoreContext' is updated to include the changed
     setting.

   * The weight of the stafflines is now heavier at smaller staff sizes.
     The font has been modified to match this look: at smaller sizes,
     the font is heavier and the note heads are more rounded.

   * Processing scores is now done while parsing the file. New Scheme
     functions give more flexibility: for example, it is now possible
     interpret a score, collecting synchronized musical events in a
     list, and manipulate that information using inline Scheme. For an
     example, see `input/no-notation/recording.ly'.

   * Font sizes can now truly be scaled continuously: the  `font-size'
     is similar to the old `font-relative-size', but may be set to
     fractional values; the closest design size will be scaled to
     achieve the desired size. As a side-effect, there are now no longer
     limitations in using smaller fonts (eg. grace notes) at small staff
     sizes.

   * Stem tips are now also engraved with rounded corners.

   * The placement of accidentals on chords and ledgered notes is
     improved.


New features in 2.0 since 1.8
*****************************

   * Crescendos can now be drawn dotted or dashed.

   * Quarter tones are now supported. They are entered by suffixing
     `ih' for a half-sharp and `eh' for a half-flat. Hence, the
     following is an ascending list of pitches:

            ceses ceseh ces ceh c cih cis cisih cisis

   * The following constructs have been removed from the syntax:

            \duration #SCHEME-DURATION
            \pitch #SCHEME-PITCH
            \outputproperty FUNC SYMBOL = VALUE

     For `\outputproperty', the following may be substituted:

             \applyoutput #(outputproperty-compatibility FUNC
                            SYMBOL VALUE)

   * Clefs may now be transposed arbitrarily, for example

            \clef "G_8"
            \clef "G_15"
            \clef "G_9"

   * The syntax for chords and simultaneous music have changed.  Chords
     are entered as

             <PITCHES>

     while simultaneous music is entered as

             <<..MUSIC LIST..>>

     In effect, the meanings of both have been swapped relative to
     their 1.8 definition.  The syntax for lists in `\markup' has
     changed alongside, but figured bass mode was not  changed, i.e.:

            \markup { \center <..LIST OF MARKUPS..> }
            \figure { <FIGURES> }

     As chords the more often used than simultaneous music, this change
     will save keystrokes.

   * Each music expression can now be tagged, to make different printed
     versions from the same music expression.  In the following example,
     we see two versions of a piece of music, one for the full score,
     and one with cue notes for the instrumental part:

          << \tag #'part <<
               { c4 f2 g4 }      % in the part, we have cue-notes
               \\ R1 >>
            \tag #'score R1  % in the score: only a rest
          >>

     The same can be applied to articulations, texts, etc.: they are
     made by prepending

                  -\tag #YOUR-TAGS

     to an articulation, for example,

                  c4-\tag #'with-fingerings -4 -\tag #'with-strings \6

     This defines a note, which has a conditional fingering and a
     string-number indication.

   * The settings for chord-fingering are more flexible. You can
     specify a list where fingerings may be placed, eg.

          	\property Voice.fingeringOrientations = #'(left down)

     This will put the fingering for the lowest note below the chord,
     and the rest to the left.

   * The script previously known as `ly2dvi' has been renamed to
     `lilypond'. The binary itself is now installed as `lilypond-bin'.

   * Markup text (ie. general text formatting) may now be used for
     lyrics too.

   * Two new commands for grace notes have been added, `\acciaccatura'
     and `\appoggiatura',

            \appoggiatura f8 e4
            \acciaccatura g8 f4

     Both reflect the traditional meanings of acciaccatura and
     appogiatura, and both insert insert a slur from the first grace
     note to the main note.

   * Layout options for grace notes are now stored in a context
     property, and may now be set separately from musical content.

   * The `\new' command will create a context with a unique name
     automatically. Hence, for multi-staff scores, it is no longer
     necessary to invent arbitrary context names. For example, a
     two-staff score may be created by

            \simultaneous {
              \new Staff { NOTES FOR 1ST STAFF }
              \new Staff { NOTES FOR 2ND STAFF }
            }

   * Octave checks make octave errors easier to correct.  The syntax is

            \octave PITCH

     This checks that PITCH (without octave) yields PITCH (with octave)
     in \relative mode. If not, a warning is printed, and the octave is
     corrected.

   * All articulations must now be entered postfix. For example,

          	c8[( d8])

     is a pair of beamed slurred eighth notes.

   * The definition of `\relative' has been simplified.  Octaves are
     now always propagated in the order that music is entered. In the
     following example,

            PRE
            \repeat "unfold" 3  BODY \alternative { ALT1 ALT2 }
            POST

     the octave of BODY is based on PRE, the starting octave of ALT1 on
     BODY, the starting octave of ALT2 on ALT1, and the starting octave
     of POST on ALT2.

     The same mechanism is used for all other music expressions, except
     the chord. Backwards compatibility is retained through a special
     program option, which is set through

            #(ly:set-option 'old-relative)

   * Windows users can double click a `.ly' file to process and view it
     automagically through the new `lily-wins' frontend.


New features in 1.8 since 1.6
*****************************

   * The chord entry code has been completely rewritten. It is now
     cleaner and more flexible.

   * A new syntax has been added for text entry.  This syntax is more
     friendly than the old mechanism, and it is implemented in a more
     robust and modular way. For more information, refer to the section
     on "Text markup" in the notation manual.

   * The integration of the input language and Scheme has been made
     deeper: you can now use LilyPond identifiers in Scheme, and use
     Scheme expressions instead of LilyPond identifiers.

   * The internal representation of music has been cleaned up completely
     and converted to Scheme data structures.  The representation may be
     exported as XML.

   * A new uniform postfix syntax for articulation has been introduced.
     A beamed slurred pair of eighth notes can be entered as

          	c8-[-( d8-]-)

     In version 2.0, postfix syntax will be the only syntax available,
     and the dashes will become optional.

     This will simplify the language: all articulations can be entered
     as postfix, in any order.

   * A new syntax has been added for chords:

          	<< PITCHES >>

     It is not necessary to update files to this syntax, but it will be
     for using LilyPond version 2.0.  In version 2.0, this syntax will
     be changed to

          	< PITCHES >

     for chords, and

          	\simultaneous { .. }

     for simultaneous music.

     To convert your files from <PITCHES> to <<PITCHES>>, use the script
     included in buildscripts/convert-new-chords.py

     This change was introduced for the following reasons

        * It solves the "start score with chord" problem, where you
          have to   state \context Voice explicitly when a chord was
          the start of a   Staff or Score.

        * With the new syntax, it is possible to distinguish between
          articulations (or fingerings) which are for a single chord
          note,   and which are for the entire chord. This allows for
          per-note   fingerings, and is more logical on the whole.

   * User code may now be executed during interpreting.  The syntax for
     this code is

          	\applycontext #SCHEME-FUNCTION

   * User code may now be executed on arbitrary grobs during
     interpreting.  The syntax for this feature is

          	\applyoutput #SCHEME-FUNCTION

     SCHEME-FUNCTION takes a single argument, and is called for every
     grob that is created in the current context.

   * New algorithms for chord-name formatting have been installed. They
     can be tuned and have ergonomic syntax for entering exceptions.

   * Texts may now be put on multimeasure rests, e.g.

          	R1*20^\markup { "GP" }

   * Ancient notation now prints ligatures in Gregorian square neumes
     notation, roughly following the typographical style of the Liber
     hymnarius of Solesmes, published in 1983.  Ligatures are still
     printed without the proper line breaking and horizontal spacing.

   * Glissandi can now be printed using the zigzag style.

   * LilyPond can now print clusters. The syntax is

          	\apply #notes-to-clusters { NOTE NOTE .. }

   * For irregular meters, beat grouping marks can be printed. The
     syntax for this is

          	#(set-time-signature 7 8 '(3 2 2))

   * Nested horizontal brackets for music analysis can now be printed:

          	NOTE-\startGroup
          		..
          	NOTE-\stopGroup

   * Ottava brackets are now fully supported as a feature.  The syntax
     is

          	#(set-octavation 1)

   * Metronome markings are printed when a \tempo command is processed.

   * Fingerings can be put on chords horizontally.

   * The appearance of various glyphs has been fine-tuned.

   * Different types of percent style repeats may now be nested.

   * The emacs support has been extended.

   * The manual has been completely revised and extended.


New features in 1.6 since 1.4
*****************************

   * Support for figured bass and tablature.

   * Completely rewritten beam formatting: provides much better output
     now.

   * Completely revised and improved music font.

   * Completely rewritten MIDI import support.

   * Completely rewritten grace note support. Practically speaking this
     means that grace notes can be slurred to normal normal notes.

   * Improved accidental handling and formatting: styles for producing
     cautionaries may vary, and complex collisions between accidentals
     of a chord are handled much better.

   * Better spacing: both globally and locally. This includes subtle
     details like optical stem spacing.

   * More support for ancient notation: mensural ligatures, ambitus
     (pitch range) of voices, more shapes, etc.

   * More support for piano notation: bracket pedals, directed
     arpeggios, arpeggio brackets.

   * Easier music polyphonic music entry.

   * More extensibility, many speedups and bugfixes

   * The manual has been thoroughly revised.

   * Development is now hosted at http://savannah.gnu.org, and sources
     can be downloaded through anonymous CVS.

   * Support for windows: LilyPond is part of the cygwin distribution,
     which comes with a user-friendly installer.


